//+------------------------------------------------------------------+
//|                                                           MA.mq4 |
//|                                                          maia666 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "maia666"
#property link      ""
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Red
double Buf_0[],Buf_1[],Buf_2[],Buf_3[]; //    

//=========================   ========================

extern int PerMa1=12;
extern int PerMa2=20;
extern int DayAnaliz=6;
extern bool PerM5=true;
extern int ProcentBuy=70;
extern int ProcentSell=30;
extern int ma_shift=0;
extern int ma_method=0;
extern int applied_price=PRICE_CLOSE;

//======================   =======================

//               


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));

SetIndexBuffer (0,Buf_0);
SetIndexStyle (0, DRAW_ARROW, STYLE_SOLID, 3);
SetIndexArrow (0, 233);

SetIndexBuffer (1,Buf_1);
SetIndexStyle (1, DRAW_ARROW, STYLE_SOLID, 3);        // DRAW_ARROW   
SetIndexArrow (1, 234);                               //   .

SetIndexBuffer (2,Buf_2);
SetIndexStyle (2,DRAW_LINE,STYLE_DOT,1);

SetIndexBuffer (3,Buf_3);
SetIndexStyle (3,DRAW_LINE,STYLE_SOLID,2);

return(INIT_SUCCEEDED);  
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---         ---
   datetime nullbar = TimeCurrent();
   int PerTF=PERIOD_M15; //         
   int PerTFm=PERIOD_M5; //       
   datetime TFSek=0;
   double KolVoSimVal=0;
   int Kotirovka=0, cxBars, Counted_bars;
   datetime Sutki=86400;
   int SistemPerFor=0;
   int TekTF=0;
   bool newbar = false;
   bool vishemast = true; //  .   
   bool nigemast = true; //  . 
   static datetime PrevTime;
   double iMa1_0, iMa1_1, iMa2_0, iMa2_1, iMa3_0, iMa3_1, iMa4_0, iMa4_1;
//---
   
   //---      ---
   if(PrevTime != Time[0])
      PrevTime=Time[0];
   else return 0;
  
   Counted_bars=IndicatorCounted();
   cxBars=MathMax(1,100-Counted_bars);     //   500       .
   
   
   
   for(int i=0; i<cxBars; i++)
   {
      iMa1_0=iMA(Symbol(),PerTF,PerMa1,ma_shift,ma_method,applied_price,i);         //  0   i- 
      iMa1_1=iMA(Symbol(),PerTF,PerMa1,ma_shift,ma_method,applied_price,i+1);       //  0   i- 
      iMa2_0=iMA(Symbol(),PerTF,PerMa2,ma_shift,ma_method,applied_price,i);         //  1   i- 
      iMa2_1=iMA(Symbol(),PerTF,PerMa2,ma_shift,ma_method,applied_price,i+1);       //  1   i- 
      iMa3_0=iMA(Symbol(),PerTFm,PerMa1,ma_shift,ma_method,applied_price,i);        //  2   i- 
      iMa3_1=iMA(Symbol(),PerTFm,PerMa1,ma_shift,ma_method,applied_price,i+1);      //  2   i- 
      iMa4_0=iMA(Symbol(),PerTFm,PerMa2,ma_shift,ma_method,applied_price,i);        //  3   i- 
      iMa4_1=iMA(Symbol(),PerTFm,PerMa2,ma_shift,ma_method,applied_price,i+1);      //  3   i- 
      
      //---    . 
      if(iMa1_1 <= iMa2_1)
      {
         if(iMa1_0 > iMa2_0)
         {
            //if(Bid > iMa2_0 || Bid > iMa1_0)     //            Bid           ,        0     .
            //{
               vishemast = true;
               nigemast = false;
               
               Buf_0[i]= Low[i];                   //     .
            //}
         }
      }

      if(iMa1_1 >= iMa2_1)
      {
         if(iMa1_0 < iMa2_0)
         {
            //if(Bid < iMa2_0 || Bid < iMa1_0)
            //{
               vishemast = false;
               nigemast = true;
               //Alert("  !");
               
               Buf_1[i]= High[i];
            //}
         }
      }
     
     /*
     
     //Print(Buf_2[0]," - Buf_2[0]",Buf_3[0]," - Buf_3[0]",Buf_2[1]," - Buf_2[1]",Buf_3[1]," - Buf_3[1]");
    
      if(Buf_2[1]>=Buf_3[1])
      {
         if(Buf_2[0]<Buf_3[0])
         {
            if(Bid<Buf_2[0] || Bid<Buf_3[0])
            {
               Alert("   !");
            }
         }
      }
   
    
      if(Buf_2[1]<=Buf_3[1])
      {
         if(Buf_2[0]>Buf_3[0])
         {
            if(Bid>Buf_2[0] || Bid>Buf_3[0])
            {
               Alert("   !");
            }
         }
      }
      */
     
   }


//--- return value of prev_calculated for next call
   return(rates_total);

//+------------------------------------------------------------------+
 }
 
